diff --git a/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java b/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
index 72e2cbde3..76b30f83e 100644
--- a/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
+++ b/src/main/java/net/minecraft/client/gui/GuiControllerSetup.java
@@ -1,260 +1,226 @@
 package net.minecraft.client.gui;
 
-import static org.lwjgl.opengl.GL11.*;
-
-import net.java.games.input.Component;
 import net.minecraft.client.input.InputHandler;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.input.controller.ControllerType;
 import net.minecraft.client.input.controller.Joystick;
 import net.minecraft.core.lang.I18n;
+import org.lwjgl.opengl.GL11;
+
+import java.util.Arrays;
+
+import static org.lwjgl.opengl.GL11.*;
+
+public class GuiControllerSetup extends GuiScreen {
+    private ControllerInput lastController = null;
+    private GuiButton controllerButton;
+    private ControllerGlyphRenderer glyphRenderer;
+
+    public GuiControllerSetup(GuiScreen parentScreen) {
+        super(parentScreen);
+    }
+
+    @Override
+    public void init() {
+        controllerButton = new GuiButton(0, 0, 0, "");
+        controllerButton.xPosition = width / 2 - 100;
+        controllerButton.yPosition = 16;
+        controllerButton.width = 200;
+        controllerButton.height = 20;
+
+        controlList.add(controllerButton);
+
+        controlList.add(new GuiButton(-1, width / 2 - 100, height - 40, I18n.getInstance().translateKey("gui.controller_setup.button.back")).setListener((e) -> mc.displayGuiScreen(parentScreen)));
+
+        this.glyphRenderer = new ControllerGlyphRenderer(mc);
+
+        updateDisplay();
+    }
+
+    @Override
+    public void tick() {
+        super.tick();
+        if (mc.controllerInput != lastController) {
+            updateDisplay();
+            lastController = mc.controllerInput;
+        }
+    }
+
+    @Override
+    public void drawScreen(int mouseX, int mouseY, float partialTick) {
+        drawDefaultBackground();
+        super.drawScreen(mouseX, mouseY, partialTick);
+
+        ControllerInput controller = mc.controllerInput;
+
+
+        if (controller != null) {
+            boolean swapJoystickAndDPad = controller.getType().getCategory() == ControllerType.Category.XBOX || controller.getType().getCategory() == ControllerType.Category.NINTENDO;
+            int y = height / 2 - 64;
+
+            glDisable(GL_DEPTH_TEST);
+            glDisable(GL_CULL_FACE);
+            glDisable(GL_TEXTURE_2D);
+            if (swapJoystickAndDPad) {
+                drawJoystick(controller.joyLeft, width / 2 - 100 + 8, y + 32 + 4 + 8);
+            } else {
+                drawJoystick(controller.joyLeft, width / 2 - 48, y + 96);
+            }
+            drawJoystick(controller.joyRight, width / 2 - 48 + 64, y + 96);
+
+            int x1 = width / 2;
+
+            GL11.glEnable(GL_TEXTURE_2D);
+            fontRenderer.drawCenteredString("(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
+
+            int w = glyphRenderer.getButtonSizeU(controller, controller.buttonLeftTrigger);
+            glyphRenderer.drawButton(controller, controller.buttonLeftTrigger, x1 - 65 - w, y, controller.buttonLeftTrigger.isPressed());
+            glyphRenderer.drawButton(controller, controller.buttonRightTrigger, x1 + 65, y, controller.buttonRightTrigger.isPressed());
+            w = glyphRenderer.getButtonSizeU(controller, controller.buttonBack);
+            glyphRenderer.drawButton(controller, controller.buttonBack, x1 - 20 - w, y + 32, controller.buttonBack.isPressed());
+            glyphRenderer.drawButton(controller, controller.buttonStart, x1 + 20, y + 32, controller.buttonStart.isPressed());
+            w = glyphRenderer.getButtonSizeU(controller, controller.buttonLeftShoulder);
+            glyphRenderer.drawButton(controller, controller.buttonLeftShoulder, x1 - 65 - w, y + 15, controller.buttonLeftShoulder.isPressed());
+            glyphRenderer.drawButton(controller, controller.buttonRightShoulder, x1 + 65, y + 15, controller.buttonRightShoulder.isPressed());
+
+            //Buttons
+            drawButtons(controller, width / 2 + 50, y + 32);
+
+            //Digital Pad
+            if (swapJoystickAndDPad) {
+                glyphRenderer.drawDPad(controller, x1 - 48 - 8, y + 96 - 8, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
+            } else {
+                glyphRenderer.drawDPad(controller, x1 - 48 - 8, y + 96 - 8, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
+            }
+
+        }
+    }
+
+    private void drawButtons(ControllerInput controller, int x, int y) {
+        int w = 20;
+
+        glyphRenderer.drawButton(controller, controller.buttonA, x + w * 1, y + w * 2, controller.buttonA.isPressed());
+        glyphRenderer.drawButton(controller, controller.buttonB, x + w * 2, y + w * 1, controller.buttonB.isPressed());
+        glyphRenderer.drawButton(controller, controller.buttonX, x + w * 0, y + w * 1, controller.buttonX.isPressed());
+        glyphRenderer.drawButton(controller, controller.buttonY, x + w * 1, y + w * 0, controller.buttonY.isPressed());
+    }
+
+    private void drawDPad(ControllerInput controller, int x, int y) {
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
+        glColor3d(1.0, 1.0, 1.0);
+        glBegin(GL_QUADS);
+
+        rectangle(x, y, 48, 48, 0, 64, 48, 48);
+
+        if (controller.digitalPad.up.isPressed())
+            rectangle(x + 18, y + 0, 12, 18, 66, 64, 12, 18);
+        if (controller.digitalPad.down.isPressed())
+            rectangle(x + 18, y + 30, 12, 18, 66, 94, 12, 18);
+        if (controller.digitalPad.left.isPressed())
+            rectangle(x + 0, y + 18, 18, 12, 48, 82, 18, 12);
+        if (controller.digitalPad.right.isPressed())
+            rectangle(x + 30, y + 18, 18, 12, 78, 82, 18, 12);
+
+        glEnd();
+
+    }
+
+    @Override
+    public void keyTyped(char c, int i, int mouseX, int mouseY) {
+
+    }
+
+    private void drawJoystick(Joystick joystick, int x, int y) {
+        glDisable(GL_TEXTURE_2D);
+
+        glBegin(GL_QUADS);
+        glColor3d(0.5, 0.5, 0.5);
+        rectangle(x, y, 32, 32);
+        glColor3d(0.0, 1.0, 0.0);
+        if (joystick.getButton().isPressed()) glColor3d(1.0, 0.0, 0.0);
+        rectangle(x + (joystick.getX() * 0.5 + 0.5) * 32 - 1, y + (joystick.getY() * 0.5 + 0.5) * 32 - 1, 2, 2);
+        glEnd();
+
+        glEnable(GL_TEXTURE_2D);
+    }
+
+    private void rectangle(double x, double y, double w, double h) {
+        glVertex2d(x, y);
+        glVertex2d(x + w, y);
+        glVertex2d(x + w, y + h);
+        glVertex2d(x, y + h);
+    }
+
+    private void rectangle(double x, double y, double w, double h, int u0, int v0, int uw, int vh) {
+        double u1 = u0 + uw;
+        double v1 = v0 + vh;
+        glTexCoord2d(u0 / 256.0, v0 / 256.0);
+        glVertex2d(x, y);
+        glTexCoord2d(u1 / 256.0, v0 / 256.0);
+        glVertex2d(x + w, y);
+        glTexCoord2d(u1 / 256.0, v1 / 256.0);
+        glVertex2d(x + w, y + h);
+        glTexCoord2d(u0 / 256.0, v1 / 256.0);
+        glVertex2d(x, y + h);
+    }
+
+    @Override
+    protected void buttonPressed(GuiButton button) {
+        super.buttonPressed(button);
+
+        if (button.id == 0) {
+            int index;
+            if (mc.controllerInput == null) {
+                index = 0;
+            } else {
+                index = Arrays.asList(InputHandler.controllers).indexOf(mc.controllerInput);
+                do {
+                    index++;
+                    if (index >= InputHandler.controllers.length) {
+                        index = -1;
+                        break;
+                    }
+                } while (InputHandler.controllers[index] == null);
+            }
+            if (index == -1) {
+                mc.controllerInput = null;
+                mc.setInputType(InputType.KEYBOARD);
+            } else {
+                mc.controllerInput = InputHandler.controllers[index];
+                mc.setInputType(InputType.CONTROLLER);
+            }
+            updateDisplay();
+            save();
+        }
+    }
+
+    @Override
+    public void onClosed() {
+        if (mc.inputType == InputType.CONTROLLER) {
+            mc.mouseInput.grabCursor();
+        }
+    }
+
+    private void updateDisplay() {
+        if (mc.controllerInput != null) {
+            controllerButton.displayString = mc.controllerInput.getController().getName();
+            if (controllerButton.displayString.startsWith("SDL GameController ")) {
+                controllerButton.displayString = controllerButton.displayString.substring(19);
+            }
+        } else {
+            controllerButton.displayString = I18n.getInstance().translateKey("gui.controller_setup.label.no_controller_selected");
+        }
+    }
+
+    private void save() {
+        if (mc.controllerInput != null) {
+            mc.gameSettings.selectedController.value = mc.controllerInput.getGUID();
+        } else {
+            mc.gameSettings.selectedController.value = "";
+        }
+        mc.gameSettings.saveOptions();
+    }
 
-public class GuiControllerSetup extends GuiScreen{
-	
-	private int selectedController = 0;
-	
-	private GuiButton controllerButton;
-	
-	public GuiControllerSetup(GuiScreen parentScreen) {
-		super(parentScreen);
-	}
-	
-	@Override
-	public void init() {
-		addButtons();
-	}
-	
-	public void addButtons() {
-		controllerButton = new GuiButton(0, 0, 0, "");
-		controllerButton.xPosition = width / 2 - 100;
-		controllerButton.yPosition = 16;
-		controllerButton.width = 200;
-		controllerButton.height = 20;
-		
-		controlList.add(controllerButton);
-
-//		if(selectedController >= 0)
-//		controlList.add(new GuiButton(-1, width / 2 - 100, height - 61, "Reset Buttons").setListener((e) -> InputHandler.controllers.get(selectedController).setLayout1()));
-		controlList.add(new GuiButton(-1, width / 2 - 100, height - 40, I18n.getInstance().translateKey("gui.controller_setup.button.back")).setListener((e) -> mc.displayGuiScreen(parentScreen)));
-		updateController();
-	}
-	
-	@Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick) {
-		drawDefaultBackground();
-		super.drawScreen(mouseX, mouseY, partialTick);
-
-		ControllerInput controller;
-		if(selectedController >= 0 && InputHandler.controllers.size() > 0) {
-			controller = InputHandler.controllers.get(selectedController);
-		}else {
-			controller = null;
-		}
-		
-		if (controller == null)
-		{
-			drawStringCentered(fontRenderer, I18n.getInstance().translateKey("gui.controller_setup.label.help.1"), width / 2, 46, 0xFFFFFFFF);
-			drawStringCentered(fontRenderer, I18n.getInstance().translateKey("gui.controller_setup.label.help.2"), width / 2, 58, 0xFFFFFFFF);
-		}
-		
-		if(controller != null) {
-			int i = 0;
-
-			glDisable(GL_DEPTH_TEST);
-			glDisable(GL_CULL_FACE);
-			glDisable(GL_TEXTURE_2D);
-			
-			for(Component comp : controller.getController().getComponents()) {
-				float data = comp.getPollData();
-				int dataD = (int)(data * 256f);
-				if(comp.isAnalog()) data = data * 0.5f + 0.5f;
-				
-				int x1 = 8;
-				int y1 = 16 + i * 10;
-				int w = 32;
-				
-				glDisable(GL_TEXTURE_2D);
-				
-				glBegin(GL_QUADS);
-				glColor3d(0.2, 0.2, 0.2);
-				rectangle(x1, y1, w, 10);
-				glEnd();
-				
-				glBegin(GL_QUADS);
-				glColor3d(1.0, 1.0, 1.0);
-				rectangle(x1 + data * w - 1, y1, 2, 10);
-				glEnd();
-
-				glEnable(GL_TEXTURE_2D);
-				if(comp.isAnalog()) {
-					fontRenderer.drawStringWithShadow(comp.getIdentifier() + ": " + data, 48, 16 + i++ * 10, 0xffffff);
-				}else {
-					fontRenderer.drawStringWithShadow(comp.getIdentifier() + ": " + dataD, 48, 16 + i++ * 10, 0xffffff);
-				}
-				
-				
-			}
-			
-			glDisable(GL_DEPTH_TEST);
-			glDisable(GL_CULL_FACE);
-			glDisable(GL_TEXTURE_2D);
-			
-//			glEnable(GL_TEXTURE_2D);
-//			glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/controller.png"));
-//			drawTexturedModalRect(width / 2 - 64, height / 2 - 46, 0, 0, 128, 92);
-			
-			glDisable(GL_TEXTURE_2D);
-			drawJoystick(controller.joyLeft, width / 2 - 48, 64);
-			drawJoystick(controller.joyRight, width / 2 - 48 + 64, 64);
-
-			glEnable(GL_TEXTURE_2D);
-			glEnable(GL_TEXTURE_2D);
-			glColor3d(1.0, 1.0, 1.0);
-			
-			int x1 = width / 2 - 200;
-			
-//			fontRenderer.drawStringWithShadow("A", x1+128, 132, controller.buttonA.isPressed() ? 0xFFFFFF : 0x505050);
-//			fontRenderer.drawStringWithShadow("B", x1+138, 132, controller.buttonB.isPressed() ? 0xFFFFFF : 0x505050);
-//			fontRenderer.drawStringWithShadow("X", x1+148, 132, controller.buttonX.isPressed() ? 0xFFFFFF : 0x505050);
-//			fontRenderer.drawStringWithShadow("Y", x1+158, 132, controller.buttonY.isPressed() ? 0xFFFFFF : 0x505050);
-
-			glEnable(GL_TEXTURE_2D);
-			
-			fontRenderer.drawStringWithShadow("ZL", x1+168, 132, controller.buttonZL.isPressed() ? 0xFFFFFF : 0x505050);
-			fontRenderer.drawStringWithShadow("ZR", x1+188, 132, controller.buttonZR.isPressed() ? 0xFFFFFF : 0x505050);
-			fontRenderer.drawStringWithShadow("-", x1+208, 132, controller.buttonMinus.isPressed() ? 0xFFFFFF : 0x505050);
-			fontRenderer.drawStringWithShadow("+", x1+218, 132, controller.buttonPlus.isPressed() ? 0xFFFFFF : 0x505050);
-			fontRenderer.drawStringWithShadow("L", x1+228, 132, controller.buttonL.isPressed() ? 0xFFFFFF : 0x505050);
-			fontRenderer.drawStringWithShadow("R", x1+238, 132, controller.buttonR.isPressed() ? 0xFFFFFF : 0x505050);
-			
-			glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/controller/xbox360.png"));
-
-			glColor3d(1.0, 1.0, 1.0);
-			glBegin(GL_QUADS);
-			
-			//Buttons
-			{
-				int x2 = width / 2 + 50;
-				int y2 = height / 2;
-				int w2 = 20;
-				
-				rectangle(x2+w2*1, y2+w2*2, w2, w2,  0, controller.buttonA.isPressed() ? 20 : 0, 20, 20);
-				rectangle(x2+w2*2, y2+w2*1, w2, w2, 20, controller.buttonB.isPressed() ? 20 : 0, 20, 20);
-				rectangle(x2+w2*0, y2+w2*1, w2, w2, 40, controller.buttonX.isPressed() ? 20 : 0, 20, 20);
-				rectangle(x2+w2*1, y2+w2*0, w2, w2, 60, controller.buttonY.isPressed() ? 20 : 0, 20, 20);
-			}
-			
-//			//Digital Pad (Small)
-//			{
-//				int x2 = width / 2 - 50;
-//				int y2 = height / 2;
-//				
-//				rectangle(x2, y2, 24, 24, 0, 40, 24, 24);
-//
-//				if(controller.digitalPad.up.isPressed())
-//					rectangle(x2 +  9, y2 +  0, 6, 9, 33, 40, 6, 9);
-//				if(controller.digitalPad.down.isPressed())
-//					rectangle(x2 +  9, y2 + 15, 6, 9, 33, 55, 6, 9);
-//				if(controller.digitalPad.left.isPressed())
-//					rectangle(x2 +  0, y2 +  9, 9, 6, 24, 49, 9, 6);
-//				if(controller.digitalPad.right.isPressed())
-//					rectangle(x2 + 15, y2 +  9, 9, 6, 39, 49, 9, 6);
-//			}
-			
-			//Digital Pad (Big)
-			{
-				int x2 = width / 2 - 100;
-				int y2 = height / 2 + 4;
-				
-				rectangle(x2, y2, 48, 48, 0, 64, 48, 48);
-
-				if(controller.digitalPad.up.isPressed())
-					rectangle(x2 + 18, y2 +  0, 12, 18, 66, 64, 12, 18);
-				if(controller.digitalPad.down.isPressed())
-					rectangle(x2 + 18, y2 + 30, 12, 18, 66, 94, 12, 18);
-				if(controller.digitalPad.left.isPressed())
-					rectangle(x2 +  0, y2 + 18, 18, 12, 48, 82, 18, 12);
-				if(controller.digitalPad.right.isPressed())
-					rectangle(x2 + 30, y2 + 18, 18, 12, 78, 82, 18, 12);
-			}
-			glEnd();
-
-		}
-	}
-	
-	@Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY) {
-		
-	}
-
-	public void drawJoystick(Joystick joystick, int x, int y) {
-		glBegin(GL_QUADS);
-		glColor3d(0.5, 0.5, 0.5);
-		rectangle(x, y, 32, 32);
-		glColor3d(0.0, 1.0, 0.0);
-		if(joystick.getButton().isPressed()) glColor3d(1.0, 0.0, 0.0);
-		rectangle(x + (joystick.getX() * 0.5 + 0.5) * 32 - 1, y + (joystick.getY() * 0.5 + 0.5) * 32 - 1, 2, 2);
-		glEnd();
-	}
-	
-	public void rectangle(double x, double y, double w, double h) {
-		glVertex2d(x, y);
-		glVertex2d(x+w, y);
-		glVertex2d(x+w, y+h);
-		glVertex2d(x, y+h);
-	}
-	
-	public void rectangle(double x, double y, double w, double h, int u0, int v0, int uw, int vh) {
-		double u1 = u0 + uw;
-		double v1 = v0 + vh;
-		glTexCoord2d(u0 / 256.0, v0 / 256.0);
-		glVertex2d(x, y);
-		glTexCoord2d(u1 / 256.0, v0 / 256.0);
-		glVertex2d(x+w, y);
-		glTexCoord2d(u1 / 256.0, v1 / 256.0);
-		glVertex2d(x+w, y+h);
-		glTexCoord2d(u0 / 256.0, v1 / 256.0);
-		glVertex2d(x, y+h);
-	}
-	
-	@Override
-	protected void buttonPressed(GuiButton button) {
-		super.buttonPressed(button);
-		
-		if(button.id == 0) {
-			selectedController ++;
-			if(selectedController >= InputHandler.controllers.size()) selectedController = -1;
-			controlList.clear();
-			addButtons();
-		}
-	}
-	
-	@Override
-	public void onClosed() {
-		if(mc.inputType == InputType.CONTROLLER) {
-			mc.mouseInput.grabCursor();
-		}
-	}
-	
-	public void updateController() {
-		ControllerInput controllerInput;
-		if(selectedController >= 0 && InputHandler.controllers.size() > 0) {
-			mc.setInputType(InputType.CONTROLLER);
-			controllerInput = InputHandler.controllers.get(selectedController);
-			controllerButton.displayString = controllerInput.getController().toString();
-		}else {
-			mc.setInputType(InputType.KEYBOARD);
-			controllerInput = null;
-			controllerButton.displayString = I18n.getInstance().translateKey("gui.controller_setup.label.no_controller_selected");
-		}
-		mc.controllerInput = controllerInput;
-		if(mc.controllerInput != null) {
-			mc.gameSettings.selectedController.value = mc.controllerInput.getController().toString();
-		}else {
-			mc.gameSettings.selectedController.value = "";
-		}
-		mc.gameSettings.saveOptions();
-		
-	}
-	
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiCrafting.java b/src/main/java/net/minecraft/client/gui/GuiCrafting.java
index e3cf65bf0..eafc14814 100644
--- a/src/main/java/net/minecraft/client/gui/GuiCrafting.java
+++ b/src/main/java/net/minecraft/client/gui/GuiCrafting.java
@@ -2,8 +2,8 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.ContainerWorkbench;
-import net.minecraft.core.player.inventory.InventoryPlayer;
+import net.minecraft.core.player.inventory.menu.CraftingMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
@@ -14,9 +14,9 @@ import org.lwjgl.opengl.GL11;
 public class GuiCrafting extends GuiContainer
 {
 
-    public GuiCrafting(InventoryPlayer inventoryplayer, World world, int i, int j, int k)
+    public GuiCrafting(Inventory inventoryplayer, World world, int i, int j, int k)
     {
-        super(new ContainerWorkbench(inventoryplayer, world, i, j, k));
+        super(new CraftingMenu(inventoryplayer, world, i, j, k));
     }
 
     @Override
@@ -36,9 +36,8 @@ public class GuiCrafting extends GuiContainer
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
-        int i = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/crafting.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(i);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/crafting.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
